///////////////////////////////////////////////
// Copyright
///////////////////////////////////////////////
//
// Text mode demo compo 5 invitation demo
// Copyright (c) 2002 Jari Komppa
//
//
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
// 
//
///////////////////////////////////////////////
//
// This was a fun one to do. Most of the time wasted while making
// this effect was gone to experimentation of nice values.
//
#include <math.h>
#include <string.h>

#define WIDTH 160
#define WIDTH2 78
#define HEIGHT 100
#define HEIGHT2 48

void blur(int * fb)
{
    for (int i = 322; i < 160*100; i++)
    {
        fb[i-161] = ((fb[i-322] & 0xf0f0f0) + 
                     (fb[i-320] & 0xf0f0f0) + 
                     (fb[i-318] & 0xf0f0f0) + 
                     (fb[i-160] & 0xf0f0f0) +
                     (fb[i-162] & 0xf0f0f0) +
                     (fb[i-1] & 0xf0f0f0) +
                     (fb[i] & 0xf0f0f0)) >> 3;
    }
}

void flower(int frame, int * fb)
{
    blur(fb);
    float a, b, c, ai, bi;
    ai = 0.012347f;
    bi = 0.013531f;
    a = frame * ai * 8;
    b = frame * bi * 8;
    c = 0;
    int countneeded = 500 + (int)(sin(frame * 0.0234) * 500) + 500;
#define ci (3.1415926535897932384626433832795f / countneeded)

    for (int i = 0; i < countneeded; i++)
    {
        int color = 
            ((int)(sin(i * 0.0242) * 0x8 + 0x8) << 9) +
            ((int)(sin(i * 0.0253) * 0x8 + 0x8) << 17) +
            ((int)(sin(i * 0.0264) * 0x8 + 0x8) << 1);
            
        int coord = 
            ((int)(sin(c) * sin(a)*(WIDTH2))+(WIDTH2)) +
            ((int)(cos(c) * cos(b)*(HEIGHT2))+(HEIGHT2))*WIDTH;
               
        fb[coord] += color;
        fb[coord+1] += color;
        fb[coord+2] += color;
        fb[coord+160] += color;
        fb[coord+161] += color;
        fb[coord+162] += color;
        fb[coord+320] += color;
        fb[coord+321] += color;
        fb[coord+322] += color;
                
        a += ai;
        b += bi;
        c += ci;
    }
}